package cn.com.infosec.util;

import java.math.BigInteger;

public class IPAddress {
   private static final BigInteger ZERO = BigInteger.valueOf(0L);

   public static boolean isValid(String address) {
      return isValidIPv4(address) || isValidIPv6(address);
   }

   private static boolean isValidIPv4(String address) {
      if (address.length() == 0) {
         return false;
      } else {
         int var1 = 0;
         address = address + ".";
         int var2 = 0;

         while(true) {
            int var3;
            if (var2 < address.length() && (var3 = address.indexOf(46, var2)) > var2) {
               if (var1 == 4) {
                  return false;
               }

               BigInteger var10000;
               boolean var10001;
               try {
                  var10000 = new BigInteger;
               } catch (NumberFormatException var6) {
                  var10001 = false;
                  return false;
               }

               BigInteger var4;
               BigInteger var7 = var4 = var10000;

               try {
                  var7.<init>(address.substring(var2, var3));
               } catch (NumberFormatException var5) {
                  var10001 = false;
                  return false;
               }

               if (var10000.compareTo(ZERO) != -1 && var4.compareTo(BigInteger.valueOf(255L)) != 1) {
                  var2 = var3 + 1;
                  ++var1;
                  continue;
               }

               return false;
            }

            if (var1 == 4) {
               return true;
            }

            return false;
         }
      }
   }

   private static boolean isValidIPv6(String address) {
      if (address.length() == 0) {
         return false;
      } else {
         int var1 = 0;
         address = address + ":";
         int var2 = 0;

         while(true) {
            int var3;
            if (var2 < address.length() && (var3 = address.indexOf(58, var2)) > var2) {
               if (var1 == 8) {
                  return false;
               }

               BigInteger var10000;
               boolean var10001;
               try {
                  var10000 = new BigInteger;
               } catch (NumberFormatException var6) {
                  var10001 = false;
                  return false;
               }

               BigInteger var4;
               BigInteger var7 = var4 = var10000;

               try {
                  var7.<init>(address.substring(var2, var3), 16);
               } catch (NumberFormatException var5) {
                  var10001 = false;
                  return false;
               }

               if (var10000.compareTo(ZERO) != -1 && var4.compareTo(BigInteger.valueOf(65535L)) != 1) {
                  var2 = var3 + 1;
                  ++var1;
                  continue;
               }

               return false;
            }

            if (var1 == 8) {
               return true;
            }

            return false;
         }
      }
   }
}
